import { Action } from "redux";
import { ActionCreator } from "redux-typescript-actions";
export interface ReducerBuilder<InS extends OutS, OutS> {
    case<P>(actionCreator: ActionCreator<P>, handler: Handler<InS, OutS, P>): ReducerBuilder<InS, OutS>;
    (state: InS | undefined, action: Action): OutS;
}
export interface Handler<InS extends OutS, OutS, P> {
    (state: InS, payload: P): OutS;
}
export declare function reducerWithInitialState<S>(initialValue: S): ReducerBuilder<S, S>;
export declare function reducerWithoutInitialState<S>(): ReducerBuilder<S, S>;
export declare function upcastingReducer<InS extends OutS, OutS>(): ReducerBuilder<InS, OutS>;
